//xsetaseta@gmail.com
//20/09/2015
//___Arduino_1.0.5___________-
//Debian 7

#include <SoftwareSerial.h> //Librería que permite establecer comunicación serie en otros pins


//Aquí conectamos los pins RXD,TDX del módulo Bluetooth.
SoftwareSerial BT(A0,A1); // RX, TX.
char entradaBT[100]; 
int contadorBT=0;
char inCharBT;



unsigned char segmentos[60]={255,255,255,255,255,255,255,255,255,255,255,255,255,191,127,255, //space-/
                            192,249,146,176,169,164,132,241,128,161,  //0-9
                            254,253,251,190,239,223,163, // : - @
                            129,140,198,152,134,135,196,141,253,216,143,206,193,157,156,131,161,159,164,199,200,220,136,137,223,182}; // A-Z
unsigned char display[3];
unsigned char led[3];
char VARI[10];
char VARI_scroll[80];
char scroll;

//mode 0  ->scroll_ON
//mode 1  ->scroll_OFF
//mode 2  ->literal led    ---no implementado
char mode=0;

unsigned char z,zz;
unsigned int tiempo,tiempo1;
int num;

String inputString = "";  
//char fileplay[20] ;


void setup() 
{            
  Serial.begin(9600); 
  BT.begin(38400); //Velocidad del puerto del módulo Bluetooth
  inputString.reserve(80);  
  for(z=2;z<13;z++)  pinMode(z, OUTPUT);
  for(z=2;z<13;z++)  digitalWrite(z, HIGH);  
  Serial.println("Empieza a escribir ");
  sprintf(VARI_scroll," H0LA MUND0 ");

  num=16; 
}

void loop()
{
  //delayMicroseconds(1); 
 InBluetooth();
  
  if(tiempo>100)
    {
     tiempo=0;
     DisplayP();
    }
  tiempo++;
 
  if(tiempo1>10000)
    {
     tiempo1=0;
     DisplayScroll();                                                                                                                                                                                                                                                     
    }
  tiempo1++;   
  
}




void DisplayScroll()
{
  display[2]=VARI_scroll[scroll]-32;
  display[1]=VARI_scroll[scroll+1]-32;
  display[0]=VARI_scroll[scroll+2]-32;  
  if(mode==0)scroll++;
  if(VARI_scroll[scroll+2]==0) scroll=0;
}

void DisplayS(char *cade)
{
  display[2]=cade[0]-32;
  display[1]=cade[1]-32;
  display[0]=cade[2]-32; 
}  

void DisplayN(int numero)
{
  sprintf(VARI,"%03d",numero);
  display[2]=VARI[0]-32;
  display[1]=VARI[1]-32;
  display[0]=VARI[2]-32;
}  

void DisplayP()
{
  SetSegmento(1,display[0]);
  SetSegmento(2,display[1]);
  SetSegmento(3,display[2]);
}

void SetSegmento( unsigned char segmento,unsigned char n)
{
 unsigned char x,z;
  switch (segmento) 
    {
    case 1:
          digitalWrite(10, HIGH);
      break;
    case 2:
          digitalWrite(11, HIGH);
      break;
    case 3:
          digitalWrite(12, HIGH);
      break;    
    }
  if(n>60)n=0;
  x=segmentos[n];

  for(z=2;z<10;z++)  
    {     
      if(x & 0x01)
         digitalWrite(z, HIGH);
       else  
         digitalWrite(z, LOW);
      x=x>>1;
    }
 delay(2);
 digitalWrite(10, LOW);   digitalWrite(11, LOW);   digitalWrite(12, LOW);
}



void InBluetooth()
{
  while (BT.available())
   {
    inCharBT = (char)BT.read(); 
    entradaBT[contadorBT]=inCharBT;
    contadorBT++;  
    if (inCharBT == '\n')
        {
          entradaBT[contadorBT]=0;
          Serial.println(entradaBT);
          for(z=0;z<=contadorBT;z++)
            {
              if(entradaBT[z]>='a'&& entradaBT[z]<='z') entradaBT[z]=entradaBT[z]-32; //Minusculas a mayusculas
            }
          memcpy(VARI_scroll,entradaBT,79);
          contadorBT=0;          
          
          if(VARI_scroll[0]=='/')
           {
             mode=1;
             VARI_scroll[0]=32;
             scroll=1;
           }
           else
           {
             mode=0;
             scroll=0;
           }          
        }   
   } 
}


void serialEvent() 
{
  while (Serial.available()) 
   {
    char inChar = (char)Serial.read(); 
    inputString += inChar;
    //if (inChar == '\n')   //Arduino terminal
    if (inChar == 13)       //Proteus
       {         
         inputString.toUpperCase();
         inputString.toCharArray(VARI_scroll,79);
         if(VARI_scroll[0]=='/')
           {
             mode=1;
             VARI_scroll[0]=32;
             scroll=1;
           }
           else
           {
             mode=0;
             scroll=0;
           }
         inputString="";                
       }
   }
}
